/************************************************
Thermometr +1000 Cortex M0 
Write by Sergi 1.11.2017
************************************************/

#include <stm32f0xx.h>
#include "1110Graf.h"
#include "i2c_soft.h"
#include <stdlib.h>
#include <string.h>

int Dsec_fl = 0,chg_fl,v_count=0,v_fl,key,key_p,ptr = 0,cpt_fl = 0,mem = 0,mode = 1,on_fl = 0,slt_fl = 0;
int Vbat,Ichg,Vchg,Vbat_s[64],Ichg_s[64],Vchg_s[64];
signed int Tt_s[64],Tt,Td_s[64],Td,T,temp,Tset = 2340,dT = 120;
char txt[16];

void init_gpio(void)
	{
		RCC->AHBENR|=RCC_AHBENR_GPIOAEN;
		RCC->AHBENR|=RCC_AHBENR_GPIOBEN;
		
		GPIOA->MODER |=  GPIO_MODER_MODER0;			//Tout
		GPIOA->MODER |=  GPIO_MODER_MODER1;			//Tin
		GPIOA->MODER |=  GPIO_MODER_MODER2;			//VBAT
		GPIOA->MODER |=  GPIO_MODER_MODER3;			//ICHG
		GPIOA->MODER |=  GPIO_MODER_MODER4;			//VCHG
	
		GPIOA->MODER &=~  GPIO_MODER_MODER6;		
		GPIOA->MODER |= GPIO_MODER_MODER6_0;		// LED
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_6;			//PUSHPULL
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR6;  
		GPIOA->BSRR |= GPIO_BSRR_BS_6;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER8;		//PowKEY
		GPIOA->MODER &=~  GPIO_MODER_MODER9;		//Key1
		GPIOA->MODER &=~  GPIO_MODER_MODER10;		//Key2
		GPIOA->MODER &=~  GPIO_MODER_MODER11;		//Key3
		
		GPIOB->MODER &=~  GPIO_MODER_MODER0;		
		GPIOB->MODER |= GPIO_MODER_MODER0_0;		// POW_ON
		GPIOB->OTYPER &=~ GPIO_OTYPER_OT_0;			//PUSHPULL
		GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR0;  
		GPIOB->BSRR |= GPIO_BSRR_BS_0;	
		
		GPIOB->MODER &=~  GPIO_MODER_MODER1;	//TIM14_CH1	
		GPIOB->MODER |= GPIO_MODER_MODER1_0;		 
		GPIOB->OTYPER &=~ GPIO_OTYPER_OT_1;			
		GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR1; 
		GPIOB->BSRR |= GPIO_BSRR_BR_1;
		
		GPIOB->MODER &=~  GPIO_MODER_MODER4;	//OUT or TIM3_CH1
		GPIOB->MODER |= GPIO_MODER_MODER4_0;		 
		GPIOB->OTYPER &=~ GPIO_OTYPER_OT_4;			
		GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR4; 
		GPIOB->BSRR |= GPIO_BSRR_BR_4;

		GPIOB->MODER &=~  GPIO_MODER_MODER6;		//I2C_SCL
		GPIOB->OTYPER |= GPIO_OTYPER_OT_6;							     
		GPIOB->MODER |= GPIO_MODER_MODER6_0;		
		GPIOB->BSRR = GPIO_BSRR_BS_6;
	
		GPIOB->MODER &=~  GPIO_MODER_MODER7;		//I2C_SDA
		GPIOB->OTYPER |= GPIO_OTYPER_OT_7;							     
		GPIOB->MODER |= GPIO_MODER_MODER7_0;		
		GPIOB->BSRR = GPIO_BSRR_BS_7;
	};
void SysTick_Handler(void)
	{
	Dsec_fl = 1;
	if (++v_count > 600) v_count = 0,v_fl = 1;
	};

void init_adc(void)
	{
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN; 
	RCC->CR2 |= RCC_CR2_HSI14ON; 
	while ((RCC->CR2 & RCC_CR2_HSI14RDY) == 0)   {  };
	if ((ADC1->CR & ADC_CR_ADEN) != 0) 
		{
		ADC1->CR &= (uint32_t)(~ADC_CR_ADEN);  
		}
	ADC1->CR |= ADC_CR_ADCAL; 
	while ((ADC1->CR & ADC_CR_ADCAL) != 0)   {  };  
	__NOP();__NOP(); 
	ADC1->CFGR1 |= ADC_CFGR1_AUTOFF;
	ADC1->CHSELR = ADC_CHSELR_CHSEL17; 
	ADC1->SMPR |= ADC_SMPR1_SMPR_0 | ADC_SMPR1_SMPR_1 | ADC_SMPR1_SMPR_2;  
	ADC1->CR |= ADC_CR_ADEN; 
	};

int read_adc(uint16_t chann)
	{	
	ADC1->CR &=~ ADC_CR_ADSTART;
  ADC1->CR |= ADC_CR_ADSTP;      
  ADC1->CHSELR = (1<<chann);
	ADC1->CR &=~ ADC_CR_ADSTP;
	ADC1->CR |= ADC_CR_ADSTART; 
  while (!(ADC1->ISR & ADC_ISR_EOC)){};
	return ADC1->DR;
	};
void init_tim14 (void)
{
	RCC->APB1ENR |= RCC_APB1ENR_TIM14EN;      
	TIM14->CR1 |= TIM_CR1_ARPE;
	TIM14->CR2 |= TIM_CR2_OIS1;
	TIM14->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;
	TIM14->CCMR1 |= TIM_CCMR1_OC1FE;
	TIM14->CCER |= TIM_CCER_CC1E;
	TIM14->PSC = 65-1;			
	TIM14->ARR = 1000-1;		//tim14 generate 1 kHz 
	TIM14->CCR1 = TIM14->ARR>>1;	//duty		
	TIM14->BDTR |= TIM_BDTR_MOE;
	//TIM14->CR1 |= TIM_CR1_CEN;
};

void beep (int time)
{
	GPIOB->MODER &=~  GPIO_MODER_MODER1;
	GPIOB->MODER |= GPIO_MODER_MODER1_1;
	TIM14->CR1 |= TIM_CR1_CEN;
	delay_us(time*1000);
	TIM14->CR1 &=~ TIM_CR1_CEN;
	GPIOB->MODER &=~  GPIO_MODER_MODER1;
	GPIOB->MODER |= GPIO_MODER_MODER1_0;
	GPIOB->BSRR |= GPIO_BSRR_BR_1;
};
void save_settings (void)
{
	i2c_write_data(10,Tset & 0xff);
	i2c_write_data(11,Tset >> 8);
	i2c_write_data(12,dT & 0xff);
	i2c_write_data(13,dT >> 8);
};
void load_settings(void)
{
	Tset = 0;
	Tset |= (int)(i2c_read_data(11))<<8 | i2c_read_data(10);
	dT = 0;
	dT |= (int)(i2c_read_data(13))<<8 | i2c_read_data(12);
};
void PrtBatToBuf (int U)
{
	int Hb = 5,Wb = 20,Xb = 9,Yb = 3,i,dUb;
	if (U >=4200) U = 4200;
		else if (U<=3500) U = 3500;
	dUb = 700/(Wb-2);
	PutLineToBuf(Xb,Yb+2,Xb,Yb+Hb-2,0);
	PutLineToBuf(Xb+1,Yb,Xb+1,Yb+Hb,0);
	PutLineToBuf(Xb+Wb,Yb,Xb+Wb,Yb+Hb,0);
	PutLineToBuf(Xb+2,Yb,Xb+Wb-1,Yb,0);
	PutLineToBuf(Xb+2,Yb+Hb,Xb+Wb-1,Yb+Hb,0);
	for (i=0;i<(Wb-2);i++)
	{
		if(U >= (3500+i*dUb)) PutLineToBuf(Xb+Wb-1-i,Yb+1,Xb+Wb-1-i,Yb+Hb-1,0);
			else PutLineToBuf(Xb+Wb-1-i,Yb+1,Xb+Wb-1-i,Yb+Hb-1,1);
	};
};

int main(void)
	{
		
		RCC->CR |= RCC_CR_HSEON;
		while (!(RCC->CR & RCC_CR_HSERDY)) {};
		FLASH->ACR |= FLASH_ACR_PRFTBE;
		FLASH->ACR |= FLASH_ACR_LATENCY;	
		RCC->CFGR |= RCC_CFGR_PLLSRC_HSE_PREDIV;
		RCC->CFGR |= RCC_CFGR_PLLXTPRE;
		RCC->CFGR2 = (4-1);								// 	26/4
		RCC->CFGR |= (10-2)<<18; 					/// Xtall/4*10=65
		RCC->CR |= RCC_CR_PLLON;
		while (!(RCC->CR & RCC_CR_PLLRDY)) {}; 
		RCC->CFGR |= RCC_CFGR_SW_PLL;
		RCC->CFGR |= RCC_CFGR_HPRE_DIV1;    
		RCC->CFGR |= RCC_CFGR_PPRE_DIV1;
		RCC->APB2ENR |= RCC_APB2ENR_SYSCFGEN;
		init_gpio();	
		SysTick_Config(6500000); // .1sek	
		if (~((GPIOA->IDR)>>8) & 0x01)  on_fl = 1;	//control entry mode
		if (~((GPIOA->IDR)>>8) & 0x08)  slt_fl = 1;	//control silent mode
		init_lcd();	
		init_adc();
		init_tim14();
		load_settings();
		beep(40);delay_us(1000000);
		while(1)
		{
			if (Dsec_fl) 
			{
			Dsec_fl = 0;lbuf_clear();
				
			if (++ptr > 63) ptr = 0;			//condition measurement
			temp = (read_adc(2)*104)>>6;
			Vbat -= Vbat_s[ptr]; Vbat_s[ptr] = temp; Vbat+=temp;
			temp = (read_adc(3)*47)>>7;	  	
			Ichg -= Ichg_s[ptr]; Ichg_s[ptr] = temp; Ichg+=temp; 
			temp = (read_adc(4)*161)>>6;
			Vchg-= Vchg_s[ptr]; Vchg_s[ptr] = temp; Vchg+=temp;
			temp = (read_adc(1)-1120)>>2;					//inside sensor
			Tt-=Tt_s[ptr];Tt_s[ptr] = temp;Tt+=temp;
			temp = ((read_adc(0)-717)*277)>>6;		//outside sensor
			Td-=Td_s[ptr];Td_s[ptr] = temp;Td+=temp;
			T = (Td>>6)+(Tt>>6);
			if ((Vchg>>6) > 4000) chg_fl = 1; else chg_fl = 0;//charger plug
			if (((Ichg>>6) < 40) && chg_fl) cpt_fl = 1;				//charge completed
					
			if (read_adc(0) >=4000)			//connection sensor test
			{
				PrtStrToBuf(" !",15,42,0);	//no connect
				GPIOB->BSRR |= GPIO_BSRR_BR_4;
				key =  (~((GPIOA->IDR)>>8) & 0x01);
				if (key == 1) //power off
				{
						lcd_clear();
						GPIOB->BSRR |= GPIO_BSRR_BR_0,GPIOA->BSRR |= GPIO_BSRR_BR_6;
						delay_us(5000000);
				};			
			itoa((Tt>>6)/10,txt);temp = 12*strlen(txt);PrtBigDigToBuf(txt,(60-temp),9,0); //inside sensor set
			itoa((Tt>>6)%10,txt);PrtBigDigToBuf(txt,63,9,0);PutLineToBuf(60,23,59,23,0),PutLineToBuf(60,22,59,22,0);
			PrtStrToBuf("C",77,17,0);			
			} else {			//connect ok
			itoa(T/10,txt);temp = 12*strlen(txt);PrtBigDigToBuf(txt,(60-temp),9,0);		//outside sensor set
			itoa(T%10,txt);PrtBigDigToBuf(txt,63,9,0);PutLineToBuf(60,23,59,23,0),PutLineToBuf(60,22,59,22,0);
			PrtStrToBuf("C",77,17,0);
				
			key =  (~((GPIOA->IDR)>>8) & 0x0f);						
			if (key)
			{
				key_p++;
				if((key_p ==1) || (key_p == 21)) beep(2);
				if (key == 1)	//key "on"
				{
					on_fl = 1;GPIOA->BSRR |= GPIO_BSRR_BS_6;
					if (key_p >= 20)			//power off
					{
						lcd_clear();
						GPIOB->BSRR |= GPIO_BSRR_BR_0,GPIOA->BSRR |= GPIO_BSRR_BR_6;
						save_settings();
						delay_us(5000000);
					};
					if (mode) mode = 0;else mode = 1;	//change focus string
				};
				if (key == 4)		//key "-"
				{
					if(mode) {
					if(Tset > 0) 
					{
						if(key_p <= 20)	Tset-=10; else Tset-=100;};
					} else {
					if(dT > 10) dT-=10;	
					};
				};
				if (key == 2)		//key "+"
				{
					if(mode) {
					if(Tset < 10000) 
					{
					if(key_p <= 20)	Tset+=10; else Tset+=100;};
					} else {
					if(dT < 500) dT+=10;	
					};
				};	
				if (key == 8)	//key "load"
				{	
					on_fl = 1;GPIOA->BSRR |= GPIO_BSRR_BS_6;
					if (mem) mem = 0;else mem = 1;	
					delay_us(500000);
				};
			} else	key_p = 0;
		
			if (mem) 
			{
				if (!mode) 		//focus marker set
			{
				PrtStrToBuf(" ",90,26,0),PrtStrToBuf(" ",90,42,1);
				PrtStrToBuf(" ",90,34,0),PrtStrToBuf(" ",90,50,1);
			}	else {
				PrtStrToBuf(" ",90,26,1),PrtStrToBuf(" ",90,42,0);
				PrtStrToBuf(" ",90,34,1),PrtStrToBuf(" ",90,50,0);
			};
				itoa(Tset/10,txt);temp = 12*strlen(txt);PrtBigDigToBuf(txt,(60-temp),26,0);//level set
				itoa(Tset%10,txt);PrtBigDigToBuf(txt,63,26,0);PutLineToBuf(60,39,59,39,0),PutLineToBuf(60,40,59,40,0);
				PrtStrToBuf("C",77,34,0);PrtStrToBuf("Yc",9,34,0);
				itoa(dT/10,txt);temp = 12*strlen(txt);PrtBigDigToBuf(txt,(60-temp),42,0);	//delta set
				itoa(dT%10,txt);PrtBigDigToBuf(txt,63,42,0);PutLineToBuf(60,55,59,55,0),PutLineToBuf(60,56,59,56,0);
				PrtStrToBuf("C",77,50,0);PrtStrToBuf("dT",9,50,0);
			
				if (T >= (Tset+dT)) //OUT to POWER SWITCH
				{
					GPIOB->BSRR |= GPIO_BSRR_BR_4;
					if (!slt_fl) beep(20);
				}	else	if (T <= (Tset-dT)) GPIOB->BSRR |= GPIO_BSRR_BS_4; else if (!slt_fl) beep(1);
				
				if (GPIOB->ODR & 0x10) 	//power out set
					{
						PutLineToBuf(10,62,86,62,0),PutLineToBuf(10,63,86,63,0);
						PutLineToBuf(10,64,86,64,0),PutLineToBuf(10,65,86,65,0);
					}	else {
						PutLineToBuf(10,62,86,62,1),PutLineToBuf(10,63,86,63,1);
						PutLineToBuf(10,64,86,64,1),PutLineToBuf(10,65,86,65,1);
					};
			} else GPIOB->BSRR |= GPIO_BSRR_BR_4;	//desable out
		};
			PrtBatToBuf(Vbat>>6);		//battery set
			if (!cpt_fl) PrtStrToBuf("    ",50,2,0); else PrtStrToBuf("full",50,2,0); //control charge set
			if (chg_fl) PrtStrToBuf("chg",78,2,0); else PrtStrToBuf("   ",78,2,0),cpt_fl = 0;
			
			if (!on_fl)		//for only charge
			{				
				if (read_adc(4)<1000) //power off
				{
						lcd_clear();
						GPIOB->BSRR |= GPIO_BSRR_BR_0,GPIOA->BSRR |= GPIO_BSRR_BR_6;
						delay_us(5000000);	
				};
				if (v_fl) GPIOA->BSRR |= GPIO_BSRR_BR_6; else GPIOA->BSRR |= GPIO_BSRR_BS_6; //lcd bl off
			};
				send_lbuf();
			};
		};
}
	
